var prop = require('propper');

module.exports = {
  name: 'collection',
  selector: '[data-type=collection][data-path]',
  update: function(el, newValue, path) {
    newValue = newValue || {};

    //force the fields to reload their content in the collection
    if (this.oldData) {
      prop(this.oldData, path, {});
    }

    var sortHash = function(item) {
      if (item.weight !== undefined) {
        return item.weight;
      }
      return item.added;
    };

    var sortedKeys = Object.keys(newValue).sort(function(a, b) {
      var aSortHash = sortHash(newValue[a]);
      var bSortHash = sortHash(newValue[b]);
      if (aSortHash === bSortHash) {
        return 0;
      }
      if (aSortHash < bSortHash) {
        return -1;
      }
      return 1;
    });

    var sortedValues = {};
    sortedKeys.forEach(function(key, index) {
      var value = newValue[key];
      value.index = index;
      sortedValues[key] = value;
    });

    var childTemplate = el.dataset.childTemplate;
    if (!childTemplate) {
      childTemplate = el.dataset.childTemplate = el.innerHTML;
    }

    el.innerHTML = Object.keys(sortedValues || {}).map(function(id) {
      return childTemplate.replace(/data-(path|show|hide|href)="([^"]*)"/g, function(match, p, path) {
        return 'data-' + p + '="' + id + (path === '.' ? '' : '/' + path) + '"';
      });
    }).join('');
  },

  hash: function(obj) {
    if (obj === undefined) {
      return undefined;
    }

    return Object.keys(obj).join();
  }
};