var extractFbPath = require('../extract-fb-path');
var store = require('store');

module.exports = {
  name: 'img',
  selector: 'img[data-path]',
  update: function(el, newValue) {
    var fbPath = extractFbPath(el);

    el.style.display = newValue ? '' : 'none';
    if (newValue) {
      var thumbKey = 'thumb:' + newValue.lastModified + ':' + fbPath;
      var thumbSrc = store.get(thumbKey);
      if (thumbSrc) {
        el.src = thumbSrc;
      } else {
        this.uploadsRef.child(fbPath + '/thumb').once('value', function(snapshot) {
          el.src = store.set(thumbKey, snapshot.val());
        });
      }
    }
  }
};