var prop = require('propper');

module.exports = extractFbPath;

function extractFbPath(el, leafProp) {
  var leafProps;
  if (leafProp) {
    leafProps = [leafProp];
  } else {
    leafProps = ['path', 'show', 'hide', 'href'];
  }

  var path;
  for (var i = 0; i < leafProps.length; i++) {
    path = prop(el, ['dataset', leafProps[i]]);
    if (path) {
      leafProp = leafProps[i];
      break;
    }
  }

  var pathParts = extractPathParts(el.parentNode);
  if (path) {
    pathParts.push(path);
  }

  return el.dataset[leafProp] = collapsePathParts(pathParts);
}

function extractPathParts(el) {
  var parts = [];
  do {
    parts.push(el.dataset.path);
    el = el.parentNode;
  } while (el && el.dataset);

  return parts.filter(Boolean).reverse();
}

function collapsePathParts(parts) {
  var cleanParts = [];

  parts.join('/').split('/').forEach(function(part) {
    if (part === '') {
      cleanParts = [];
    } else if (part === '..') {
      cleanParts.pop();
    } else if (part !== '.') {
      cleanParts.push(part);
    }
  });

  return '/' + cleanParts.join('/');
}