module.exports = Sequence;

function Sequence(content) {
  this.each = function(fn) {
    content.forEach(fn);
  };

  this.map = function(fn) {
    return content.map(fn);
  };

  this.remove = function(matcher) {
    var index = indexOf(matcher);
    if (index > -1) {
      content.splice(index, 1);
    }
  };

  this.replace = function(matcher, newItem) {
    var index = indexOf(matcher);
    if (index > -1) {
      content.splice(index, 1, newItem);
    }
  };

  this.insertBefore = function(matcher, item) {
    var index = indexOf(matcher);
    if (index === -1) {
      throw new Error('Item not found');
    }

    content = content.splice(index, 0, item);
  };

  this.insertAfter = function(matcher, item) {
    var index = indexOf(matcher);
    if (index === -1) {
      throw new Error('Item not found');
    }

    content = content.splice(index + 1, 0, item);
  };

  this.append = function(item) {
    content.push(item);
  };

  function indexOf(matcher) {
    if (typeof matcher !== 'function') {
      var item = matcher;
      matcher = function(i) {
        return i === item;
      };
    }

    for (var i = 0; i < content.length; i++) {
      if (matcher(content[i])) {
        return i;
      }
    }

    return -1;
  }
}

